%%%% This code helps to covert the listfile data
clear
clc

%%%% first delet all the texts 06042022
%%% check the size(data)/30016 == cycle in the text

% textread txt as cell
% aa=textread('TESTj.txt','%s');
aa=textread('TEST06042022.lst','%s'); %%% input the name of the listfile

%%read the sweep and time info
bb=cell2mat(aa);
% 16 to 10
% cc=hex2dec(bb);
% %10 to 2
% dd=dec2bin(cc)
% num2str(cc, 16)
cc=dec2bin(hex2dec(bb));
dd=cc;
ee=bin2dec(cc(:,1:16));
ff=bin2dec(cc(:,17:44));

%% calculate the cut point of the sweeps at every 65535 (1111111111111111)
p_end=[];
for i = 2: length(ee)
    if (ee(i)-ee(i-1))<0
        p_end = [p_end, i-1];
    end
end
p_end=[p_end,length(ee)];
%%% correct the sweep number
new_ee=[];
new_ee = [new_ee, ee(1:(p_end(1)))]; %%%%  the first cycle of 65535
for i = 2: length(p_end)
    new_ee_add= ee((p_end(i-1)+1):(p_end(i)))+65535*(i-1);
    new_ee = [new_ee; new_ee_add ];
end

%%%% covert the data to the software
N_bins=30016;
sweep=3600;
For_length=(fix(max(new_ee)/sweep)+1)*N_bins;
data=zeros(For_length,1);
sweep_time=[new_ee, ff];

for j= 1: For_length
    cycle=fix(j/N_bins);
    time_j=j-cycle*N_bins;
    for k= 1: length(new_ee)
        
    if fix(new_ee(k)/sweep)==cycle
        if (time_j*4-4)<=ff(k) && (time_j*4-1)>=ff(k)
        data(j)=data(j)+1;
        end
    end

    end
end

sumadata=sum(data);



% max(new_ee)/3600



% ee=bin2dec(cc(:,17:44));
% 10 to 2
% dd=dec2bin(cc)


% table = [];
% for i = (1:length(cc))
%     a = reverse(cc(i,:));
%     table(i) = bin2dec(a(:,32:48));
% end
% plot(table)
% % % 
% % % 
% % % figure(1)
% % % plot(ee)
% % % figure(2)
% % % plot(new_ee)
% % % figure(3)
% % % % plot(ff)
% % % histogram(ff,1000)